#include <sys/wait.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <ucontext.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int
main(int argc, char *argv[])
{
  int res;
  int fd;
  char buf;


  // #########################################################
  // On test s'il y a un argument sur la ligne de commande pour avoir un message à échanger
  // #########################################################
  //assert(argc == 2);
  if (argc != 2) {
    fprintf(stderr, "Usage %s <nom fifo>\n", argv[0]);
    exit(2);
  }
  
  if (mkfifo(argv[1], 0644)==-1) {
    fprintf(stderr, "probleme avec la création du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }
  fd = open(argv[1], O_RDONLY);
  if (fd <= 0) {
    fprintf(stderr, "probleme avec l'ouverture du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }
  
  while ((res = read(fd, &buf, 1)) != 0) {
    if (res < 0) {
      fprintf(stderr, "Erreur pour la lecture : %s\n", strerror(errno));
      exit(14);
    }
    fprintf(stdout, "Je lit %c\n", buf);
  }

  fprintf(stdout, "Fin de la liaison\n");

  close(fd);

  if (unlink(argv[1])==-1) {
    fprintf(stderr, "Probleme avec la destruction du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }

  

  return 0;
}
